%-------------------------------------------------------------------------%
%                                                                         %
% Computes the expected shot noise given the output voltage and the       %
%   equivalent resistance for the specific gain setting                   %
%                                                                         %
%-------------------------------------------------------------------------%


function ExpSN(V,R)
    R = 2*R;            % Include the 2x gain op-amp U5
    q = 1.69*10^-19;    % charge of an electron
    I = V/R;
    i = sqrt(2*q*I);   % Currenty density
    v = i*R            % Voltage density (Vrms/SqrtHz)
end