%-------------------------------------------------------------------------%
%                                                                         %
% Amplitude-Signal Spectral Density for Dual PD Amp -- measures           %
%   the shot noise output from the board from a photodiode and LED source %
% Data from SR785                                                         %
%                                                                         %
%-------------------------------------------------------------------------%

%% Board Side A

%D0 = Off, D1 = Off, Span 102.4KHz @ 10V
data127 = importdata('SRS127.mat');
%D0 = Off, D1 = Off, Span 12.8KHz @ 10V
data128 = importdata('SRS128.mat');
%D0 = Off, D1 = Off, Span 1.6KHz @ 10V
data129 = importdata('SRS129.mat');
%D0 = Off, D1 = Off, Span 200Hz @ 10V
data130 = importdata('SRS130.mat');


%D0 = On, D1 = Off, Span 102.4KHz
data131 = importdata('SRS131.mat'); % @ 10.32V
%D0 = On, D1 = Off, Span 12.8KHz
data132 = importdata('SRS132.mat'); % @ 10.32V
%D0 = On, D1 = Off, Span 200Hz
data133 = importdata('SRS133.mat'); % @ 10.32V


%D0 = On, D1 = On, Span 102.4KHz @ 9.90V
data134 = importdata('SRS134.mat');
%D0 = On, D1 = On, Span 12.8KHz @ 9.90V
data135 = importdata('SRS135.mat');
%D0 = On, D1 = On, Span 200Hz @ 9.90V
data136 = importdata('SRS136.mat');

%D0 = Off, D1 = On, Span 102.4KHz @ 9.17V
data137 = importdata('SRS137.mat');
%D0 = Off, D1 = On, Span 12.8KHz 9.17V
data138 = importdata('SRS138.mat');
%D0 = Off, D1 = On, Span 1.6KHz 9.17V
data139 = importdata('SRS139.mat');
%D0 = Off, D1 = On, Span 200Hz 9.17V
data140 = importdata('SRS140.mat');

% Calculate shot noise by subtracting electronic noise (NS) -- need to
%   convert to power first
Sdata127(:,2) = sqrt(data127(:,2).^2-data84(:,2).^2);
Sdata128(:,2) = sqrt(data128(:,2).^2-data85(:,2).^2);
Sdata129(:,2) = sqrt(data129(:,2).^2-data86(:,2).^2);
Sdata130(:,2) = sqrt(data130(:,2).^2-data87(:,2).^2);

Sdata131(:,2) = sqrt(data131(:,2).^2-data88(:,2).^2);
Sdata133(:,2) = sqrt(data133(:,2).^2-data89(:,2).^2);

Sdata134(:,2) = sqrt(data134(:,2).^2-data90(:,2).^2);
Sdata136(:,2) = sqrt(data136(:,2).^2-data91(:,2).^2);

Sdata137(:,2) = sqrt(data137(:,2).^2-data92(:,2).^2);
Sdata138(:,2) = sqrt(data138(:,2).^2-data93(:,2).^2);
Sdata139(:,2) = sqrt(data139(:,2).^2-data94(:,2).^2);
Sdata140(:,2) = sqrt(data140(:,2).^2-data95(:,2).^2);

% Calculate average values from 1kHz to 2kHz
aveA00_S_LC = mean(data128(66:126,2));
aveA10_S_LC = mean(data131(9:17,2));
aveA11_S_LC = mean(data134(9:17,2));
aveA01_S_LC = mean(data138(66:126,2));


%% Board Side B

%D0 = Off, D1 = Off, Span 102.4KHz @ 9.6V
data141 = importdata('SRS141.mat');
%D0 = Off, D1 = Off, Span 12.8KHz @ 9.6V
data142 = importdata('SRS142.mat');
%D0 = Off, D1 = Off, Span 1.6KHz @ 9.6V
data143 = importdata('SRS143.mat');
%D0 = Off, D1 = Off, Span 200Hz @ 9.6V
data144 = importdata('SRS144.mat');


%D0 = On, D1 = Off, Span 102.4KHz
data145 = importdata('SRS145.mat'); % @ 9.55V
%D0 = On, D1 = Off, Span 12.8KHz
data146 = importdata('SRS146.mat'); % @ 9.55V
%D0 = On, D1 = Off, Span 200Hz
data148 = importdata('SRS148.mat'); % @ 9.55V


%D0 = On, D1 = On, Span 102.4KHz @ 9.90V
data149 = importdata('SRS149.mat');
%D0 = On, D1 = On, Span 12.8KHz @ 9.90V
data150 = importdata('SRS150.mat');
%D0 = On, D1 = On, Span 200Hz @ 9.90V
data151 = importdata('123.mat');

%D0 = Off, D1 = On, Span 102.4KHz @ 9.95V
data152 = importdata('SRS003.mat');
%D0 = Off, D1 = On, Span 12.8KHz 9.95V
data153 = importdata('SRS004.mat');
%D0 = Off, D1 = On, Span 1.6KHz 9.95V
data154 = importdata('SRS007.mat');
%D0 = Off, D1 = On, Span 200Hz 9.95V
data155 = importdata('SRS008.mat');

% Calculate shot noise by subtracting electronic noise (NS) -- need to
%   convert to power first
Sdata141(:,2) = sqrt(data141(:,2).^2-data47(:,2).^2);
Sdata142(:,2) = sqrt(data142(:,2).^2-data48(:,2).^2);
Sdata143(:,2) = sqrt(data143(:,2).^2-data49(:,2).^2);
Sdata144(:,2) = sqrt(data144(:,2).^2-data50(:,2).^2);

Sdata145(:,2) = sqrt(data145(:,2).^2-data51(:,2).^2);
Sdata148(:,2) = sqrt(data148(:,2).^2-data52(:,2).^2);

Sdata149(:,2) = sqrt(data149(:,2).^2-data53(:,2).^2);
Sdata151(:,2) = sqrt(data151(:,2).^2-data54(:,2).^2);

Sdata152(:,2) = sqrt(data152(:,2).^2-data55(:,2).^2);
Sdata153(:,2) = sqrt(data153(:,2).^2-data56(:,2).^2);
Sdata154(:,2) = sqrt(data154(:,2).^2-data57(:,2).^2);
Sdata155(:,2) = sqrt(data155(:,2).^2-data58(:,2).^2);

% Calculate average values from 1kHz to 2kHz
aveB00_S_LC = mean(data142(66:126,2));
aveB10_S_LC = mean(data145(9:17,2));
aveB11_S_LC = mean(data149(9:17,2));
aveB01_S_LC = mean(data153(66:126,2));

%% Frequency Spans
freq1 = linspace(0,102.4,801);
freq2 = linspace(0, 12.8, 801);
freq3 = linspace(0, 1.6, 801);
freq4 = linspace(0, .2, 801);

freqvector = horzcat (freq4, freq3(1,100:801),freq2(1,100:801),freq1(1,100:801));
freqvector3 = horzcat (freq4, freq2(1,13:801), freq1(1,100:801));
freqvector2 = horzcat (freq4, freq1(1,1:801));

freq1_2 = linspace(0,102.4,200);
freq2_2 = linspace(0, 12.8, 200);
freq3_2 = linspace(0, 1.6, 200);
freq4_2 = linspace(0, .2, 200);


%% Concatenate data
% Total noise 
B00_T_LC = vertcat (data144(:,2), data143(100:801,2),data142(100:801,2),data141(100:801,2));
B10_T_LC = vertcat (data148(:,2), data146(13:801,2),data145(100:801,2));
B11_T_LC = vertcat (data151(:,2),data150(13:801,2),data149(100:801,2));
B01_T_LC = vertcat (data155(:,2), data154(100:801,2),data153(100:801,2),data152(100:801,2));

A00_T_LC = vertcat (data130(:,2), data129(100:801,2),data128(100:801,2),data127(100:801,2));
A10_T_LC = vertcat (data133(:,2),data132(13:801,2),data131(100:801,2));
A11_T_LC = vertcat (data136(:,2),data135(13:801,2),data134(100:801,2));
A01_T_LC = vertcat (data140(:,2),data139(100:801,2),data138(100:801,2),data137(100:801,2));

% Shot noise (electrical noise subtracted out)
B00_S_LC = vertcat (Sdata144(:,2), Sdata143(100:801,2),Sdata142(100:801,2),Sdata141(100:801,2));
B10_S_LC = vertcat (Sdata148(:,2),Sdata145(1:801,2));
B11_S_LC = vertcat (Sdata151(:,2),Sdata149(1:801,2));
B01_S_LC = vertcat (Sdata155(:,2), Sdata154(100:801,2),Sdata153(100:801,2),Sdata152(100:801,2));

A00_S_LC = vertcat (Sdata130(:,2), Sdata129(100:801,2),Sdata128(100:801,2),Sdata127(100:801,2));
A10_S_LC = vertcat (Sdata133(:,2),Sdata131(1:801,2));
A11_S_LC = vertcat (Sdata136(:,2),Sdata134(1:801,2));
A01_S_LC = vertcat (Sdata140(:,2),Sdata139(100:801,2),Sdata138(100:801,2),Sdata137(100:801,2));
%% Slide B Plots

figure(1)
subplot(2,2,1)
loglog(freqvector, 80*10^-9); % Expected noise (not include electrical noise)
hold on
loglog(freqvector,B00_S_LC);
title(' Shot Noise for -- gain settings of side B');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
hold off
subplot(2,2,2)
loglog(freqvector, 142*10^-9); % Expected noise (not include electrical noise)
hold on
loglog(freqvector2, B10_S_LC);
title('Shot Noise for x- gain settings of side B');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
hold off
subplot(2,2,3)
loglog(freqvector, 253*10^-9); % Expected noise (not including eletrical noise)
hold on
loglog(freqvector2, B11_S_LC);
title('Shot Noise for xx gain settings of side B');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
hold off
subplot(2,2,4)
loglog(freqvector, 449*10^-9); % Expected noise (not including electrical noise)
hold on 
loglog(freqvector, B01_S_LC);
title('Shot Noise for -x gain settings of side B');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
hold off


%% Slide A Plots

figure(3)
subplot(2,2,1)
loglog(freqvector, 80*10^-9); % Expected noise (not include electrical noise)
hold on
loglog(freqvector,A00_S_LC);
title(' Shot Noise for -- gain settings of side A');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
hold off
subplot(2,2,2)
loglog(freqvector, 142*10^-9); % Expected noise (not include electrical noise)
hold on
loglog(freqvector2, A10_S_LC);
title('Shot Noise for x- gain settings of side A');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
hold off
subplot(2,2,3)
loglog(freqvector, 253*10^-9); % Expected noise (not including eletrical noise)
hold on
loglog(freqvector2, A11_S_LC);
title('Shot Noise for xx gain settings of side A');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
hold off
subplot(2,2,4)
loglog(freqvector, 449*10^-9); % Expected noise (not including electrical noise)
hold on 
loglog(freqvector, A01_S_LC);
title('Shot Noise for -x gain settings of side A');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
hold off

%% Comparison of Noise

figure(4)
loglog(freqvector, 449*10^-9,freqvector,A00_S_LC, 'b',freqvector,A00_S,'g',freqvector, A00_N);
legend('Long Cable Shot Noise','Short Cable Shot Noise', 'Electrical Noise');
title('Noise for -- gain settings of side A');
xlabel('kHz');
ylabel('Vrms/Hz^-2');
grid;
