%-------------------------------------------------------------------------%
%                                                                         %
% Transfer functions for Dual PD Amp -- measures the amplitude and phase  %
%   between the input and output signal through the board from the source %
% Data from SR785                                                         %
%                                                                         %
%-------------------------------------------------------------------------%

%% Board Side B:

% D0: Off, D1: Off (0dB)
data01 = importdata('SRS001.mat');
% D0: On, D1: Off (10dB)
data02 = importdata('SRS002.mat');
% D0: On, D1: On (20dB)
data03 = importdata('SRS012.mat');
% D0: Off, D1: On (30dB)
data04 = importdata('SRS011.mat');

%% Board Side A:

% D0: Off, D1: Off (0dB)
data05 = importdata('SRS005.mat');
% D0: On, D1: Off (10dB)
data06 = importdata('SRS006.mat');
% D0: On, D1: On (20dB)
data07 = importdata('SRS010.mat');
% D0: Off, D1: On (30dB)
data08 = importdata('SRS009.mat');



%% Frequency Range from 1Hz to 102.4KHz
freq = linspace(.001, 102.4, 200);



%% Side B Plots
figure(1);
subplot(2,1,1)
semilogx(data01(22:200,1), data01(22:200,2));
title('Amplitude Transfer Functions for -- gain settings of side B');
xlabel('Hz');
ylabel('dB');
grid;
subplot(2,1,2)
semilogx(data01(22:200,1), data01(22:200,3));
title('Phase Transfer Functions for -- gain settings of side B');
xlabel('Hz');
ylabel('Deg');
grid;

figure(2)
subplot(2,1,1)
semilogx(data02(22:200,1), data02(22:200,2));
title('Amplitude Transfer Functions for x- gain settings of side B');
xlabel('Hz');
ylabel('dB');
grid;
subplot(2,1,2)
semilogx(data02(22:200,1), data02(22:200,3));
title('Phase Transfer Functions for x- gain settings of side B');
xlabel('Hz');
ylabel('Deg');
grid;

figure (3)
subplot(2,1,1)
semilogx(data03(22:200,1), data03(22:200,2));
title('Amplitude Transfer Functions for xx gain settings of side B');
xlabel('Hz');
ylabel('dB');
grid;
subplot(2,1,2)
semilogx(data03(22:200,1), data03(22:200,3));
title('Phase Transfer Functions for xx gain settings of side B');
xlabel('Hz');
ylabel('Deg');
grid;

figure(4)
subplot(2,1,1)
semilogx(data04(22:200,1), data04(22:200,2));
title('Amplitude Transfer Functions for -x gain settings of side B');
xlabel('Hz');
ylabel('dB');
grid;
subplot(2,1,2)
semilogx(data04(22:200,1), data04(22:200,3));
title('Phase Transfer Functions for -x gain settings of side B');
xlabel('Hz');
ylabel('Deg');
grid;

%% Side A Plot
figure (5)
subplot(2,1,1)
semilogx(data05(22:200,1), data05(22:200,2));
title('Amplitude Transfer Functions for -- gain settings of side A');
xlabel('Hz');
ylabel('dB');
grid;
subplot(2,1,2)
semilogx(data05(22:200,1), data05(22:200,3));
title('Phase Transfer Functions for -- gain settings of side A');
xlabel('Hz');
ylabel('Deg');
grid;

figure(6)
subplot(2,1,1)
semilogx(data06(24:200,1), data06(24:200,2));
title('Amplitude Transfer Functions for x- gain settings of side A');
xlabel('Hz');
ylabel('dB');
grid;
subplot(2,1,2)
semilogx(data06(24:200,1), data06(24:200,3));
title('Phase Transfer Functions for x- gain settings of side A');
xlabel('Hz');
ylabel('Deg');
grid;

figure(7)
subplot(2,1,1)
semilogx(data07(22:200,1), data07(22:200,2));
title('Amplitude Transfer Functions for xx gain settings of side A');
xlabel('Hz');
ylabel('dB');
grid;
subplot(2,1,2)
semilogx(data07(22:200,1), data07(22:200,3));
title('Phase Transfer Functions for xx gain settings of side A');
xlabel('Hz');
ylabel('Deg');
grid;

figure(8)
subplot(2,1,1)
semilogx(data08(22:200,1), data08(22:200,2));
title('Amplitude Transfer Functions for -x gain settings of side A');
xlabel('Hz');
ylabel('dB');
grid;
subplot(2,1,2)
semilogx(data08(22:200,1), data08(22:200,3));
title('Phase Transfer Functions for -x gain settings of side A');
xlabel('Hz');
ylabel('Deg');
grid;